//=====================================================Functions to work with WinSocket 2.0============================================================
#import "ws2_32.dll"
int WSAStartup(int cmd, int &wsadata[]); 
int WSACleanup();
int WSAGetLastError();
int socket(int domaint,int type,int protocol);
int bind(int socket, int& address[], int address_len);
int connect(int socket, int& address[], int address_len);
int listen(int socket, int backlog); 
int accept(int socket, int& address[], int& address_len[]); 
int recv(int socket, char& buffer[], int length, int flags); 
int recvfrom(int socket, int& buffer[], int length, int flags, int& address[], int& address_len[]);
int send(int socket, char& buffer[], int length, int flags);
int sendto(int socket, int& message[], int length, int flags, int& dest_addr[], int dest_len);
int closesocket(int socket);
int gethostbyname(string name); 
int gethostbyaddr(string addr, int len, int type);
int inet_addr(string addr); 
string inet_ntoa(int addr );
#import

#import "user32.dll"
bool GetAsyncKeyState(int Key);
#import

#import "msvcrt.dll"
  int memcpy(float &dest, char &src[], int count);  
  int memcpy(double &dest, char &src[], int count);  
  int memcpy(int &dest, char &src[], int count);  
#import
//Fix App 
const string ENDMARK = "|";
//1 - order 2 - quote
const string cmd_command_type = "1";
const string cmd_order_client_id = "100";
//1 - market 2 - limit 3 - stop
const string cmd_order_type = "101";
//0 - buy 1 - sell
const string cmd_order_side = "102";
const string cmd_order_symbol = "103";
const string cmd_order_lot = "104";
const string cmd_order_price = "105";
const string cmd_order_sl = "106";
const string cmd_order_tp = "107";
const string cmd_order_status = "108";
const string cmd_order_slippage = "109";
const string cmd_order_ttl = "110";
const string cmd_operation_type = "112";
//Addresses
#define INADDR_ANY         0x00000000
#define INADDR_LOOPBACK    0x7f000001
#define INADDR_BROADCAST   0xffffffff
#define INADDR_NONE        0xffffffff
//ERRORS
//socket fucntions errors
#define INVALID_SOCKET             0
#define SOCKET_ERROR               -1
//WSAGatLastError() errors
// Windows Sockets definitions of regular Microsoft C error constants
#define WSAEINTR                   10004
#define WSAEBADF                   10009
#define WSAEACCES                  10013
#define WSAEFAULT                  10014
#define WSAEINVAL                  10022
#define WSAEMFILE                  10024
// Windows Sockets definitions of regular Berkeley error constants
#define WSAEWOULDBLOCK             10035
#define WSAEINPROGRESS             10036
#define WSAEALREADY                10037
#define WSAENOTSOCK                10038
#define WSAEDESTADDRREQ            10039
#define WSAEMSGSIZE                10040
#define WSAEPROTOTYPE              10041
#define WSAENOPROTOOPT             10042
#define WSAEPROTONOSUPPORT         10043
#define WSAESOCKTNOSUPPORT         10044
#define WSAEOPNOTSUPP              10045
#define WSAEPFNOSUPPORT            10046
#define WSAEAFNOSUPPORT            10047
#define WSAEADDRINUSE              10048
#define WSAEADDRNOTAVAIL           10049
#define WSAENETDOWN                10050
#define WSAENETUNREACH             10051
#define WSAENETRESET               10052
#define WSAECONNABORTED            10053
#define WSAECONNRESET              10054
#define WSAENOBUFS                 10055
#define WSAEISCONN                 10056
#define WSAENOTCONN                10057
#define WSAESHUTDOWN               10058
#define WSAETOOMANYREFS            10059
#define WSAETIMEDOUT               10060
#define WSAECONNREFUSED            10061
#define WSAELOOP                   10062
#define WSAENAMETOOLONG            10063
#define WSAEHOSTDOWN               10064
#define WSAEHOSTUNREACH            10065
#define WSAENOTEMPTY               10066
#define WSAEPROCLIM                10067
#define WSAEUSERS                  10068
#define WSAEDQUOT                  10069
#define WSAESTALE                  10070
#define WSAEREMOTE                 10071
#define WSAEDISCON                 10101
// Extended Windows Sockets error constant definitions
#define WSASYSNOTREADY             10091
#define WSAVERNOTSUPPORTED         10092
#define WSANOTINITIALISED          10093
#define WSAEDISCON                 10101
#define WSAENOMORE                 10102
#define WSAECANCELLED              10103
#define WSAEINVALIDPROCTABLE       10104
#define WSAEINVALIDPROVIDER        10105
#define WSAEPROVIDERFAILEDINIT     10106
#define WSASYSCALLFAILURE          10107
#define WSASERVICE_NOT_FOUND       10108
#define WSATYPE_NOT_FOUND          10109
#define WSA_E_NO_MORE              10110
#define WSA_E_CANCELLED            10111
#define WSAEREFUSED                10112
// Authoritative Answer: Host not found 
#define WSAHOST_NOT_FOUND          11001
// Non-Authoritative: Host not found, or SERVERFAIL 
#define WSATRY_AGAIN               11002
// Non recoverable errors, FORMERR, REFUSED, NOTIMP 
#define WSANO_RECOVERY             11003
// Valid name, no data record of requested type 
#define WSANO_DATA                 11004
// no address, look for MX record 
#define WSANO_ADDRESS              11004
//Adress Families
#define AF_UNSPEC                  0
#define AF_UNIX                    1
#define AF_INET                    2
#define AF_IMPLINK                 3
#define AF_PUP                     4
#define AF_CHAOS                   5
#define AF_NS                      6
#define AF_IPX                     6
#define AF_ISO                     7
#define AF_OSI                     7
#define AF_ECMA                    8
#define AF_DATAKIT                 9
#define AF_CCITT                   10
#define AF_SNA                     11
#define AF_DECnet                  12
#define AF_DLI                     13
#define AF_LAT                     14
#define AF_HYLINK                  15
#define AF_APPLETALK               16
#define AF_NETBIOS                 17
#define AF_VOICEVIEW               18
#define AF_FIREFOX                 19
#define AF_UNKNOWN1                20
#define AF_BAN                     21
#define AF_ATM                     22
#define AF_INET6                   23
#define AF_CLUSTER                 24
#define AF_12844                   25
#define AF_IRDA                    26
#define AF_MAX                     27
#define PF_UNSPEC                  0
#define PF_UNIX                    1
#define PF_INET                    2
#define PF_IMPLINK                 3
#define PF_PUP                     4
#define PF_CHAOS                   5
#define PF_NS                      6
#define PF_IPX                     6
#define PF_ISO                     7
#define PF_OSI                     7
#define PF_ECMA                    8
#define PF_DATAKIT                 9
#define PF_CCITT                   10
#define PF_SNA                     11
#define PF_DECnet                  12
#define PF_DLI                     13
#define PF_LAT                     14
#define PF_HYLINK                  15
#define PF_APPLETALK               16
#define PF_VOICEVIEW               18
#define PF_FIREFOX                 19
#define PF_UNKNOWN1                20
#define PF_BAN                     21
#define PF_MAX                     27
// Types
#define SOCK_STREAM                1
#define SOCK_DGRAM                 2
#define SOCK_RAW                   3
#define SOCK_RDM                   4
#define SOCK_SEQPACKET             5
// Protocols
#define IPPROTO_IP                 0
#define IPPROTO_ICMP               1
#define IPPROTO_IGMP               2
#define IPPROTO_GGP                3
#define IPPROTO_TCP                6
#define IPPROTO_UDP                17
#define IPPROTO_IDP                22
#define IPPROTO_ND                 77
#define IPPROTO_RAW                255
#define IPPROTO_MAX                256
// Services
#define IPPORT_ECHO                7
#define IPPORT_DISCARD             9
#define IPPORT_SYSTAT              11
#define IPPORT_DAYTIME             13
#define IPPORT_NETSTAT             15
#define IPPORT_FTP                 21
#define IPPORT_TELNET              23
#define IPPORT_SMTP                25
#define IPPORT_TIMESERVER          37
#define IPPORT_NAMESERVER          42
#define IPPORT_WHOIS               43
#define IPPORT_MTP                 57
#define IPPORT_TFTP                69
#define IPPORT_RJE                 77
#define IPPORT_FINGER              79
#define IPPORT_TTYLINK             87
#define IPPORT_SUPDUP              95
#define IPPORT_EXECSERVER          512
#define IPPORT_LOGINSERVER         513
#define IPPORT_CMDSERVER           514
#define IPPORT_EFSSERVER           520
#define IPPORT_BIFFUDP             512
#define IPPORT_WHOSERVER           513
#define IPPORT_ROUTESERVER         520
#define IPPORT_RESERVED            1024
// Maximum queue length specifiable by listen.
#define SOMAXCONN                  5
#define MSG_OOB                    1
#define MSG_PEEK                   2
#define MSG_DONTROUTE              4
#define MSG_MAXIOVLEN              10
#define MSG_PARTIAL                32768
#define WS_BIGENDIAN 0

#define WSADATA 100
/*typedef struct WS(WSAData) { 
    WORD                    wVersion;
    WORD                    wHighVersion;
    char                    szDescription[WSADESCRIPTION_LEN+1];
    char                    szSystemStatus[WSASYS_STATUS_LEN+1];
    WORD                    iMaxSockets;
    WORD                    iMaxUdpDg;
    char                   *lpVendorInfo;
} WSADATA, *LPWSADATA;*/
#define WSADESCRIPTION_LEN  256
#define WSASYS_STATUS_LEN   128
#define wdVersion   131072    
#define wdHighVersion 131074  
#define wdDescription 16842756 
#define wdSystemStatus 8454405 
#define wdMaxSockets  131462   
#define wdMaxUdpDg  131464     
#define wdpVendorInfo 262538   

#define sockaddr 4
/*typedef struct WS(sockaddr) {
        u_short sa_family;
        char    sa_data[14];
} SOCKADDR, *PSOCKADDR, *LPSOCKADDR;*/
#define sa_family 131072 
#define sa_data 917506   


#define in_addr 1
/*typedef struct WS(in_addr) {
    union {
        struct {
            u_char s_b1,s_b2,s_b3,s_b4;
        } S_un_b;
        struct {
            u_short s_w1,s_w2;
        } S_un_w;
        u_long S_addr;
    } S_un;
} IN_ADDR, *PIN_ADDR, *LPIN_ADDR;
#define s_addr  S_un.S_addr
#define s_host  S_un.S_un_b.s_b2
#define s_net   S_un.S_un_b.s_b1
#define s_imp   S_un.S_un_w.s_w2
#define s_impno S_un.S_un_b.s_b4
#define s_lh    S_un.S_un_b.s_b3*/
#define s_net   65536 
#define s_host  65537 
#define s_lh    65538 
#define s_impno 65539 
#define s_imp  131074 
#define s_addr 262144 


#define sockaddr_in 5
/*typedef struct WS(sockaddr_in) {
    short              sin_family;
    u_short               sin_port;
    struct WS(in_addr) sin_addr;
    char               sin_zero[8];
} SOCKADDR_IN, *PSOCKADDR_IN, *LPSOCKADDR_IN;*/
#define sin_family      131072 
#define sin_port        131074 
#define sin_addr        262148 
#define sin_addr_s_net   65540 
#define sin_addr_s_host  65541 
#define sin_addr_s_lh    65542 
#define sin_addr_s_impno 65543 
#define sin_addr_s_imp  131078 
#define sin_addr_s_addr 262168 
#define sin_zero        524296 

//---------------------------------------------------------------
string struct2str(int &struct_buf[], int field)
{
  string r = "";
  int    l = field >> 16;
  
  if (l==0)
     return(r);
     
  field &= 0xFFFF;
  
  int p = field >> 2;
  int o = field %4;
  int x = struct_buf[p] >> (o << 3);
  
  for (l = l; l > 0; l--)
  {
    r = r + CharToString(x & 0xFF);
    if (o == 3)
    {
      o = 0;
      p++;
      x = struct_buf[p];
    }
    else
      o++;
  }
  return(r);
}
//---------------------------------------------------------------
void int2struct(int& struct_buf[], int field, int value)
{
  if (field<0) field=-field;
  int l=field>>16;
  if (l==0) return;
  if (l>4) l=4;
  field&=0xFFFF;
  int p=field>>2;
  int o=field%4;
  value         &= 0xFFFFFFFF>>((4-l)<<3);
  struct_buf[p] &= 0xFFFFFFFF>>((4-o)<<3);
  struct_buf[p] |= value << (o << 3);
  if (o+l>4)
  {
    p++;
    struct_buf[p] &= 0xFFFFFFFF<<((o+l-4)<<3);
    struct_buf[p] |= value>>((8-o-l)<<3);
  }  
}
//---------------------------------------------------------------
void str2struct(int& struct_buf[], int field, string value)
{
  int l=field>>16;
  if (l<2) return;
  field&=0xFFFF;
  int p=field>>2;
  int o=field%4;
  for (int i=0; i<StringLen(value); i++) {
    struct_buf[p]&=~(0xFF<<(o<<3));
    struct_buf[p]|=StringGetCharacter(value,i)<<(o<<3);
    if (o==3) {
      p++;
      o=0;
    } else
      o++;
    if (l==2)
      break;
    else
      l--;    
  }
  struct_buf[p]&=~(0xFF<<(o<<3));
}
//---------------------------------------------------------------
int htonl(int l) {if (WS_BIGENDIAN!=0) return(l);return(((l&0xFF)<<24) | ((l&0xFF00)<<8) | ((l&0xFF0000)>>8) | ((l&0xFF000000)>>24));}
int htons(int s) {if (WS_BIGENDIAN!=0) return(s);return(((s&0xFF)<<8) | ((s&0xFF00)>>8));}
int ntohl(int l) {if (WS_BIGENDIAN!=0) return(l);return(((l&0xFF)<<24) | ((l&0xFF00)<<8) | ((l&0xFF0000)>>8) | ((l&0xFF000000)>>24));}
int ntohs(int s) {if (WS_BIGENDIAN!=0) return(s);return(((s&0xFF)<<8) | ((s&0xFF00)>>8));} 

//Functions,classes and constants to work with BJF Feeder
//---------------------------------------------------------------
string  protocol = "TCP";
#define DEFAULT_BUFLEN 2048
#define DEFAULT_PORT 9001

string label_name = "label_status_info";
string script_name = "script_name_info";

double UnixStartDate = 25569.0;
string command_separator = "|";

int conn_socket_buy,conn_socket_sell=0;
//---------------------------------------------------------------
//Function to get parts of the IP
void GetIPParts(int &net,int &host,int &lh,int &impno,string server_addr)
{
    int pos = 0;
    int length = StringLen(server_addr);
    
    string tmp_str = "";
    while (pos<length)
    {
     if (StringSubstr(server_addr,pos,1)==".") break;
     tmp_str += StringSubstr(server_addr,pos,1);
     pos++;
    }
    net = StringToInteger(tmp_str);
    
    pos++;
    tmp_str = "";
    while (pos<length)
    {
     if (StringSubstr(server_addr,pos,1)==".") break;
     tmp_str += StringSubstr(server_addr,pos,1);
     pos++;
    }
    host = StringToInteger(tmp_str);
    
    pos++;       
    tmp_str = "";
    while (pos<length)
    {
     if (StringSubstr(server_addr,pos,1)==".") break;
     tmp_str += StringSubstr(server_addr,pos,1);
     pos++;
    }
    lh = StringToInteger(tmp_str);
    
    pos++;       
    tmp_str = "";
    while (pos<length)
    {
     if (StringSubstr(server_addr,pos,1)==".") break;
     tmp_str += StringSubstr(server_addr,pos,1);
     pos++;
    }
    impno = StringToInteger(tmp_str);
}
//---------------------------------------------------------------
//Function to get the symbol name from the code
int DateTimeToUnix(double dtDate)
{
  return MathRound((dtDate - UnixStartDate) * 86400);
}
//---------------------------------------------------------------
//Function for date conversion
bool isalpha(int c)
{
  string t="0123456789";
  return(StringFind(t,CharToString(c))<0);
  
}
//---------------------------------------------------------------
//Connection function 
bool ConnectToFixApp(int &conn_socket,string server_addr,int port)
{
    char Buffer[DEFAULT_BUFLEN];
    int retval;
    int addr[1];
    int socket_type;
    int server[sockaddr_in];
    int hp;
    int wsaData[WSADATA];
 
    if (protocol=="TCP")
      socket_type = SOCK_STREAM; 
    else if (protocol=="UDP")
      socket_type = SOCK_DGRAM;
    else {
      return false;
    }    
    if (port==0) {
       return false;
    }    
    retval = WSAStartup(0x202, wsaData);
   
    if (retval != 0) {
       Print("Client: WSAStartup() failed with error "+ retval);
       return false;
    } else
       Print("Client: WSAStartup() is OK.");
 
    if (isalpha(StringGetCharacter(server_addr,0))){
        Print("Client: IP address should be given in numeric form in this version.");
        return false;
    } else { 
        addr[0] = inet_addr(server_addr); 
        //hp = gethostbyaddr(server_addr, 4, AF_INET);
        //Print("server addr:"+addr[0]+" hp"+hp);
    }
    
    if (addr[0] == INADDR_NONE ) {
       Print("Client: Cannot resolve address \""+server_addr+"\": Error :"+WSAGetLastError());
       return false;
    }
    
    int net,host,lh,impno;
    
    int2struct(server,sin_family,AF_INET);
       
    GetIPParts(net,host,lh,impno,server_addr);
    int2struct(server,sin_addr_s_net,net);
    int2struct(server,sin_addr_s_host,host);
    int2struct(server,sin_addr_s_lh,lh);
    int2struct(server,sin_addr_s_impno,impno);
    
    
    int2struct(server,sin_port,htons(port));
 
    conn_socket = socket(AF_INET, socket_type, 0); 
    
    if (conn_socket <0 ) {
        Print("Client: Error Opening socket: Error "+ WSAGetLastError());
        return false;
    } else
       Print("Client: socket() is OK.");
 
    Print("Client: Client connecting to: "+ server_addr);
    //retval=bind(conn_socket, server, ArraySize(server)<<2);
    retval=connect(conn_socket, server, ArraySize(server)<<2);
    if (retval == SOCKET_ERROR) {
        Print("Client: connect() failed: ", WSAGetLastError());
        return false;
    }
    else
       Print("Client: connect() is OK.");
    
   ObjectSetInteger(0,label_name,OBJPROP_COLOR,clrBlueViolet);
   ObjectSetString(0,label_name,OBJPROP_TEXT,"Connected");
   ChartRedraw();
    
    return true;   
}
//---------------------------------------------------------------
//Disconnection function 
bool DisconnectFromFixApp(int conn_socket)
{
  
  int retval;
  
  if (conn_socket>0) 
  {
    while (conn_socket>0)
    {
     retval = closesocket(conn_socket);
      
    
      if (retval == SOCKET_ERROR) {
         int last_error = WSAGetLastError();      
         
         if (last_error == WSAENOTSOCK||last_error == WSAECONNABORTED||last_error == WSAECONNREFUSED)
          break;
         else
          Print("Client: closesocket() failed: error ", last_error);
         
      }
       else 
     conn_socket = 0;
     ObjectSetInteger(0,label_name,OBJPROP_COLOR,clrRed);
     ObjectSetString(0,label_name,OBJPROP_TEXT,"Disconnected");
     ChartRedraw();
    }
    
  }
  WSACleanup();
  return true;
} 
//---------------------------------------------------------------
//Receive data Function 
bool SendData(string msg,int &conn_socket,string server_addr,int port)
{
  char Buffer[DEFAULT_BUFLEN];
  int retval;
  int i, loopcount=0;
  int reconnecting_attempts = 1;
  
  int len =  StringLen(msg);
  StringToCharArray(msg,Buffer,0,len); 
      
  int last_error = WSAGetLastError();      
  retval = send(conn_socket, Buffer, len, 0);
  last_error = WSAGetLastError();      
      
      if (retval == SOCKET_ERROR) {
         Print("Client: send() failed: error ", WSAGetLastError());
      DisconnectFromFixApp(conn_socket);
      reconnecting_attempts = 1;
      while (!ConnectToFixApp(conn_socket,server_addr,port)&&!IsStopped())
        {
        Print("Reconnecting to server. Attempt number "+reconnecting_attempts++);
        Sleep(5000);//Sleeping for 30 seconds until connected 
        }
      retval = send(conn_socket, Buffer, len, 0);   
      return false;  
      }
        
      if (retval == 0) {
        Print("Client: Server closed connection.");
        DisconnectFromFixApp(conn_socket);
        reconnecting_attempts = 1;
        while (!ConnectToFixApp(conn_socket,server_addr,port)&&!IsStopped())
        {
        Print("Reconnecting to server. Attempt number "+reconnecting_attempts++);
        Sleep(5000);//Sleeping for 30 seconds until connected 
        }
       retval = send(conn_socket, Buffer, len, 0);    
       return false;
      }
  
  return true;

}  
//---------------------------------------------------------------
string GetValueFromString(string res_string,int key,int start_pos)
{
  string template_string = "|"+IntegerToString(key)+"=";
  int pos = StringFind(res_string,template_string,start_pos);
  if (pos == -1) return "";
  pos+=StringLen(template_string);
  
  string res = "";
  
  while (StringSubstr(res_string,pos,1)!="|"&&pos<StringLen(res_string))
   {
     res += StringSubstr(res_string,pos,1);
     pos++;
   }
  return res;
  
}
//---------------------------------------------------------------
bool RecvData(int &conn_socket,string server_addr,int port/*TTickData *Ticks[]*/)
{
  
  char Buffer[DEFAULT_BUFLEN];
  int retval;
  int i, loopcount=0;
  int reconnecting_attempts = 1;

    
      
      retval = recv(conn_socket, Buffer, DEFAULT_BUFLEN, 0);
      
      if (retval == SOCKET_ERROR) {
         Print("Client: recv() failed: error ", WSAGetLastError());
      DisconnectFromFixApp(conn_socket);
      reconnecting_attempts = 1;
      while (!ConnectToFixApp(conn_socket,server_addr,port)&&!IsStopped())
        {
        Print("Reconnecting to server. Attempt number "+reconnecting_attempts++);
        Sleep(5000);//Sleeping for 30 seconds until connected 
        }
         //return(-1);
      return false;  
      }
        
      if (retval == 0) {
        Print("Client: Server closed connection.");
        DisconnectFromFixApp(conn_socket);
        reconnecting_attempts = 1;
        while (!ConnectToFixApp(conn_socket,server_addr,port)&&!IsStopped())
        {
        Print("Reconnecting to server. Attempt number "+reconnecting_attempts++);
        Sleep(5000);//Sleeping for 30 seconds until connected 
        }
       return false;
      }
      
      if (retval >= DEFAULT_BUFLEN-1) {
        Print("Client: Too large packet ("+retval+" bytes) received...");
        return false;
      }
      
      char char1;
      int pos = 0;
      
      string res_string = CharArrayToString(Buffer,0, retval);   
      string template_string = "|1="; 
            
      pos = StringFind(res_string,template_string,0); 
      
      if (pos==-1) return false;
           
      
      do
      {
       char1 = Buffer[pos+3];//
      
      string symbol,lots,price,sl ,tp ,status,new_order_id,var_name,time;
      
      switch (char1)
      {
      case '1'://new order
      {
        //Print(res_string);
        string _orderid = GetValueFromString(res_string,100,pos);
        int type = GetValueFromString(res_string,101,pos);
        int side = GetValueFromString(res_string,102,pos);
        
        
        symbol = GetValueFromString(res_string,103,pos);
        lots = GetValueFromString(res_string,104,pos);
        price = GetValueFromString(res_string,105,pos);
        sl = GetValueFromString(res_string,106,pos);
        tp = GetValueFromString(res_string,107,pos);
        status  = GetValueFromString(res_string,108,pos);
        new_order_id  = GetValueFromString(res_string,111,pos);
                
        if (sl == "") sl = "0";
        if (tp == "") tp = "0";
        if (price == "") price = "0";
        if (new_order_id == "") new_order_id = "0";       
         
        var_name = "RO_"+_orderid+"_"+side+"_"+type+"_"+lots+"_"+symbol+"_"+price+"_"+sl+"_"+tp+"_"+status+"_"+new_order_id;
        GlobalVariableSet(var_name,0);
        //Print(var_name);
        break;                 
      }
      
      case '2'://new quote
      {
        string _symbol = GetValueFromString(res_string,200,pos);
        double _bid = StringToDouble(GetValueFromString(res_string,201,pos));
        double _ask = StringToDouble(GetValueFromString(res_string,202,pos));
        double vol_bid = StringToDouble(GetValueFromString(res_string,203,pos));
        double vol_ask = StringToDouble(GetValueFromString(res_string,204,pos));
        GlobalVariableSet("FIXTRADER_"+_symbol+"_BID",_bid);
        GlobalVariableSet("FIXTRADER_"+_symbol+"_ASK",_ask);
        GlobalVariableSet("FIXTRADER_"+_symbol+"_VOLBID",vol_bid);
        GlobalVariableSet("FIXTRADER_"+_symbol+"_VOLASK",vol_ask);
/*        
        GlobalVariableSet("FIXTRADER_"+_symbol+"_BID_TIME",TimeLocal());
        GlobalVariableSet("FIXTRADER_"+_symbol+"_ASK_TIME",TimeLocal());
*/        
        // Sart changed TimeLocal() to TimeCurrent(), 03.06.2016 
        GlobalVariableSet("FIXTRADER_"+_symbol+"_BID_TIME",TimeCurrent());
        GlobalVariableSet("FIXTRADER_"+_symbol+"_ASK_TIME",TimeCurrent());
        break;        
      }
      
      case '3':
       {
         string connection = GetValueFromString(res_string,300,pos);
         string conn_status = GetValueFromString(res_string,301,pos);
         string status_var_name = "Status_"; 
         if (connection == "0") 
           status_var_name+="MarketData";
         else
           status_var_name+="Trading";
         GlobalVariableSet(status_var_name,StringToDouble(conn_status));  
         if (conn_status == "0")  
          Print(status_var_name+" fix session disconnected");
         else 
          Print(status_var_name+" fix session connected");
          break;
       }
       
       case '4':
       {
         string info_type = GetValueFromString(res_string,400,pos);
         string info_value = GetValueFromString(res_string,401,pos);
         
         if (info_type == "1")
         {
          GlobalVariableSet("FIXBROKER_"+info_value,0);  
         }
         
         if (info_type == "2")
         {
          string symb = GetValueFromString(res_string,200,pos); 
          GlobalVariableSet("DIGITS_"+symb,StringToInteger(info_value));  
         }
               
         
          break;
       }
        
        case '6':
        { 
          symbol = GetValueFromString(res_string,103,pos);
          lots = GetValueFromString(res_string,104,pos);
          price = GetValueFromString(res_string,105,pos);
          sl = GetValueFromString(res_string,106,pos);
          tp = GetValueFromString(res_string,107,pos); 
          string error_message = GetValueFromString(res_string,113,pos); 
          time = StringToInteger(GetValueFromString(res_string,114,pos)); 
        
                  
          //delete global variable connected with position       
          for (i=0;i<GlobalVariablesTotal();i++)
             {
                var_name = GlobalVariableName(i);
                if (StringFind(var_name,"SETPOS_"+symbol)!=-1)
                {
                   GlobalVariableDel(var_name);
                   break;
                }     
           
                    
              }
          
          var_name = "SETPOS_"+symbol+"_"+price+"_"+sl+"_"+tp+"_"+time;
          //If position size changed
          //if (fabs(lots)>1.e-3)
           GlobalVariableSet(var_name,lots);
          
          if (error_message!="")
           Print("FIXTRADER: "+error_message);
          
          } 
             
      }
      
      
      pos = StringFind(res_string,template_string,pos+1); 
      }       
      while (pos > -1); 
     
  return true;

}
//---------------------------------------------------------------
void CleanAllGlobalVariables()
{
 Print("Cleaning global variables...");
 int total = GlobalVariablesTotal();
 for (int i=0;i<total;i++)
   {
     string var_name = GlobalVariableName(i);
     if (StringFind(var_name,"SO_",0)!=-1||
         StringFind(var_name,"RO_",0)!=-1||
         StringFind(var_name,"CO_",0)!=-1||
         StringFind(var_name,"MO_",0)!=-1||
         StringFind(var_name,"SETPOS_",0)!=-1||
         StringFind(var_name,"GETPOS_",0)!=-1||
         StringFind(var_name,"FIXBROKER_",0)!=-1||
         StringFind(var_name,"DIGITS_",0)!=-1||
         StringFind(var_name,"FIXTRADER_",0)!=-1||
         StringFind(var_name,"Status_",0)!=-1
         )
         {
           GlobalVariableDel(var_name);
           total = GlobalVariablesTotal();
           i = -1; 
         }
   } 
}
//---------------------------------------------------------------
